/* DYNAMIC SC DENSE CODE. Ranges approach version -- 
A dynamic word-based byte oriented compressor for text files based on 
(s,c)-Dense Code.

Programmed by Antonio Faria
Copyright (C) 2006  Nieves R. Brisaboa, Gonzalo Navarro, Antonio Faria and Jos R. Param
Author's contact: antonio.fari@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/*-----------------------------------------------------------------------
 Hash: Definition of HashTable class (Linear Hash)
 ------------------------------------------------------------------------*/
 
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include <malloc.h>
//#include "valstring.h"
//#include "compatibilidade.h"

#include "MemoryManager.h"


#define JUMP 101  		 //jump made when a collision arises
#define OCUP_HASH 1.5	 //index of occupation of the hash table
#define SMALL_PRIME 1009 // a small prime number, used to compute a hash function
#define SEED	1159241
/* Type definitions */

#define MIN(a,b) (a < b) ? a : b

struct Nword {
	  unsigned char *word;
	  unsigned long len;
	  unsigned long weight;
	  unsigned long posInVocab;
	  
	//  unsigned long codeword;
	//  unsigned long size;
};

typedef struct Nword t_word;


/*
 * Definition of the HashTable
 */


// private:
	//Holds dynamic memory reserve for words.
	MemoryManager _memMgr;

	unsigned long TAM_HASH;   /* Numero de entradas da tabela hash */
	unsigned long NumElem;    /* Numero de Elementos no HASH actualmente*/
	unsigned long N;  	     /* Numero de Elementos mximos do vocabulario */



	unsigned long NearestPrime (unsigned int n);
	unsigned long hashFunction (const unsigned char *aWord, unsigned int len);


// public:

	t_word  *hash;     		  /* holds a hashTable of words  */
	
	unsigned long initialize_hash  (unsigned long tamArq);
	
	unsigned long insertElement (const unsigned char *aWord, register unsigned long len,
	                                   register unsigned long *addr);
	unsigned long search (const unsigned char *aWord, register unsigned len,
								 unsigned long *returnedAddr);



